return function()

local B = CBW_Battle

local EggyFunction = function(player)
	if player.mo.state == S_PLAY_FLY then 
		CBW_Battle.SetPriority(player,0,0,"stomp",3,3,"Jet Fumes")
	 end	
	 if player.mo.state == S_PLAY_RUN and player.pflags & PF_THOKKED then 
		CBW_Battle.SetPriority(player,1,1,nil,1,1,"Egg Burst")
	 end
	 if player.mo.state == S_PLAY_ALTFALL1 or player.mo.state == S_PLAY_ALTFALL2 and player.pflags & PF_THOKKED then 
		CBW_Battle.SetPriority(player,1,1,"stomp",1,3,"Immense Weight")
	 end
	 if player.mo.state == S_PLAY_JUMP then 
		CBW_Battle.SetPriority(player,0,0,"stomp",1,2,"stomp attack")
	 end
end	

local function eggbullshit(player)
	local mo = player.mo
	B.ZLaunch(mo, 20 * mo.scale, false)
	mo.state = S_PLAY_JUMP
	mo.momy = $ * 4/5
	player.actionstate = 0
	player.actiontime = 0
	player.pflags = ($ | (PF_JUMPED | PF_STARTJUMP))
end

local function iseggburst(player)
	if not (player and player.valid and player.playerstate == PST_LIVE)
		or not player.mo
		or not (player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_FALL and player.pflags & PF_JUMPED or player.mo.state == S_PLAY_ALTFALL1 or player.mo.state == S_PLAY_ALTFALL2)
		or not player.mo.health
		return false
	end
	return true
end

B.Egg_PreCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
	if iseggburst(plr[n1])
		plr[n1].eggmarker = true
	end
end

B.Egg_PostCollide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
	if plr[n1] and plr[n1].eggmarker
		plr[n1].eggmarker = nil
	end
end

B.Egg_Collide = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
	if not (plr[n1] and plr[n1].eggmarker)
		return false
	end
	if (hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2)
		if not (plr[n2] and plr[n2].eggmarker)
			eggbullshit(plr[n1])
		end
		if plr[n2]
			B.DoPlayerTumble(plr[n2], 60, angle[n1], mo[n1].scale*3, true)
		end
		P_InstaThrust(mo[n2], angle[n2], mo[n1].scale * 5)
		B.ZLaunch(mo[n2], -15 * mo[n2].scale, false)

		return true
	end
end
	  
CBW_Battle.SkinVars["eggman"] = {
	flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
	weight = 130,
	shields = 0, 
	special = CBW_Battle.Action.RoboMissile,
	guard_frame = 6,
	func_priority_ext = EggyFunction,
	func_precollide = B.Egg_PreCollide,
	func_collide = B.Egg_Collide,
	func_postcollide = B.Egg_PostCollide,
}

end