dofile("Info_ActEggMissile.lua")
dofile("LUA_FLY")
dofile("LUA_EGGY")
dofile("LUA_EGGBOSS")
dofile("Exec_RCRoboMissile.lua")

local battleScripts = {
	dofile("LUA_ActEggMissile.lua"),
	dofile("LUA_BATTLE.lua")
}

local function LoadBattleScripts()
	for _, func in ipairs(battleScripts)
		func()
	end
end

if CBW_Battle
	LoadBattleScripts()
	return
end

local loaded = false
addHook("MapChange", function() -- make this a ThinkFrame if you want to, I don't see the point personally
	if loaded
		return
	end
	
	if CBW_Battle
		LoadBattleScripts()
		loaded = true
	end
end)